<?php

class SvtGiveoutStatusMod extends DbMod{
  var $VarTableSvtGiveoutStatusTypes = array('integer', 'text', 'text', 'integer');
  
  function SvtGiveoutStatusMod($ArrMsSp){
		parent::__construct($ArrMsSp);
		return true;
	}

	function GetFromDb($VarSqlName = 'SqlAll', $VarSqlGet = 'GetAll', $VarWhere = '', $VarOrder = '', $VarLimit = ''){
    /*** begin default values ***/
    $ArrSqlArray['SqlAll']['select'] = 'a.*';
    $ArrSqlArray['SqlAll']['from'] = $this->VarTableSvtGiveoutStatus .' AS a';
    if('' != $VarWhere){
      $ArrSqlArray['SqlAll']['where'] = $VarWhere;
    }
    if('' != $VarOrder){
      $ArrSqlArray['SqlAll']['order'] = $VarOrder;
    }
    if('' != $VarLimit){
      $ArrSqlArray['SqlAll']['limit'] = $VarLimit;
    }
    /*** end default values ***/
    ///
    $ArrSqlArray['SqlCount']['select'] = 'count(*) AS vartotal';
    $ArrSqlArray['SqlCount']['from'] = $this->VarTableSvtGiveoutStatus .' AS a';
    if('' != $VarWhere){
      $ArrSqlArray['SqlCount']['where'] = $VarWhere;
    }
    ///
    $ArrSqlArray['SqlWriteoffAll']['select'] = 'a.*, count(b._id) AS svt_count';
    $ArrSqlArray['SqlWriteoffAll']['from'] = $this->VarTableSvtGiveoutStatus .' AS a';
    $ArrSqlArray['SqlWriteoffAll']['leftjoin'] = $this->VarTableSvt .' AS b ON a.svtgiveoutstatus_id = b.svtgiveoutstatus_id AND YEAR(b.svt_date) < YEAR(NOW())-a.svtgiveoutstatus_writeoff+1';
    if('' != $VarWhere){
      $ArrSqlArray['SqlWriteoffAll']['where'] = $VarWhere;
    }
    $ArrSqlArray['SqlWriteoffAll']['group'] = 'a.svtgiveoutstatus_id';
    if('' != $VarOrder){
      $ArrSqlArray['SqlWriteoffAll']['order'] = $VarOrder;
    }
    if('' != $VarLimit){
      $ArrSqlArray['SqlWriteoffAll']['limit'] = $VarLimit;
    }
    ///
    $ArrResult = $this->DbGet($ArrSqlArray[$VarSqlName], $VarSqlGet);
  	return $ArrResult;
	}

  function Add($values){
    if(true === is_array($values) && 0 < count($values)){
      $VarSql = 'INSERT INTO '. $this->VarTableSvtGiveoutStatus .'
                (svtgiveoutstatus_id, svtgiveoutstatus_name, svtgiveoutstatus_color, svtgiveoutstatus_order)
                VALUES (?, ?, ?, ?)';
      $sth = $this->ArrMsSp->SP_DbConnect->prepare($VarSql, $this->VarTableSvtGiveoutStatusTypes, MDB2_PREPARE_MANIP);
      $values = $this->PrepareData($values);
      $ArrData = array(
        '',
        $values['svtgiveoutstatus_name'],
        $values['svtgiveoutstatus_color'],
        $values['svtgiveoutstatus_order']
      );
      //SiteLibs::GetVarDump($data);
      $VarQueryResult = $sth->execute($ArrData);
      if(PEAR::isError($VarQueryResult)) {
        return array('error' => $VarQueryResult->getMessage());
      }
      $VarId = $this->ArrMsSp->SP_DbConnect->lastInsertID($this->VarTableSvtGiveoutStatus, 'svtgiveoutstatus_id');
      if (PEAR::isError($VarId)) {
        return array('error' => $VarId->getMessage());
      }
      return $VarId;
    }
    else{
      return array('error' => $this->ArrMsSp->Sp_LangMessage['error']['ErrSettingWrong']);
    }
  }

  function Edit($values){
    if(true === is_array($values) && 0 < count($values)){
      $VarSql = "UPDATE ". $this->VarTableSvtGiveoutStatus ." SET
                  svtgiveoutstatus_name = ?,
                  svtgiveoutstatus_color = ?,
                  svtgiveoutstatus_order = ?
                  WHERE svtgiveoutstatus_id = '".  $values['svtgiveoutstatus_id'] ."'";
      $values = $this->PrepareData($values);
      $ArrData = array(
        $values['svtgiveoutstatus_name'],
        $values['svtgiveoutstatus_color'],
        $values['svtgiveoutstatus_order']
      );
      $sth = $this->ArrMsSp->SP_DbConnect->prepare($VarSql);
      $VarQueryResult = $sth->execute($ArrData);
      if(PEAR::isError($VarQueryResult)) {
        return array('error' => $VarQueryResult->getMessage());
      }
      return $values['svtgiveoutstatus_id'];
    }
    else{
      return array('error' => $this->ArrMsSp->Sp_LangMessage['error']['ErrSettingWrong']);
    }
  }

  function Del($VarId = '', $VarFiledName = 'svtgiveoutstatus_id'){
    if('' != $VarId && true === is_numeric($VarId)){
      $sql = "DELETE FROM ". $this->VarTableSvtGiveoutStatus ." WHERE ". $VarFiledName ." = '". $VarId ."'";
      //echo "sql: ". $sql ."<br />";
      $VarQueryResult = $this->ArrMsSp->SP_DbConnect->exec($sql);
      if (PEAR::isError($VarQueryResult)) {
        return array('error' => $VarQueryResult->getMessage());
      }
      return true;
    }
    else {
      return array('error' => $this->ArrMsSp->Sp_LangMessage['error']['ErrSettingWrong']);
    }
	}
  
  function PrepareData($values){
    if(true === is_array($values) && 0 < count($values)){
      $values['svtgiveoutstatus_name'] = SiteLibs::ConvertTextToSql($values['svtgiveoutstatus_name']);
      $values['svtgiveoutstatus_color'] = SiteLibs::ConvertTextToSql($values['svtgiveoutstatus_color']);
      $values['svtgiveoutstatus_order'] = SiteLibs::ConvertSqlIntegerInsert($values['svtgiveoutstatus_order']);
    }
    return $values;
  }
}
?>